###################################################
### chunk number 1: 
###################################################
#line 171 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
library(psych)
data(sat.act) 
describe(sat.act)  #basic descriptive statistics


###################################################
### chunk number 2: 
###################################################
#line 181 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
describe.by(sat.act,sat.act$gender,skew=FALSE,ranges=FALSE) #basic descriptive statistics by a grouping variable.


###################################################
### chunk number 3: 
###################################################
#line 187 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
sa.mat <- describe.by(sat.act,list(sat.act$gender,sat.act$education),
 skew=FALSE,ranges=FALSE,mat=TRUE)
head(sa.mat)
tail(sa.mat)


###################################################
### chunk number 4: 
###################################################
#line 199 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
x <- matrix(1:120,ncol=10,byrow=TRUE)
new.x <- scrub(x,3:5,min=c(30,40,50),max=70,isvalue=45)
new.x


###################################################
### chunk number 5: 
###################################################
#line 216 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
pairs.panels(sat.act)


###################################################
### chunk number 6: 
###################################################
#line 228 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(affect)
pairs.panels(flat[15:18],bg=c("red","black","white","blue")[maps$Film],pch=21,main="Affect varies by movies (study 'flat')")


###################################################
### chunk number 7: 
###################################################
#line 250 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(epi.bfi)
error.bars.by(epi.bfi[,6:10],epi.bfi$epilie<4)


###################################################
### chunk number 8: 
###################################################
#line 263 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
error.bars.by(sat.act[5:6],sat.act$gender,bars=TRUE,labels=c("Male","Female"),ylab="SAT score",xlab="")


###################################################
### chunk number 9: 
###################################################
#line 275 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(bifactor)
cor.plot(Thurstone,color=TRUE,main="9 cognitive variables from Thurstone")


###################################################
### chunk number 10: 
###################################################
#line 286 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
circ <- sim.circ(24)
r.circ <- cor(circ)
cor.plot(r.circ,color=TRUE,zlim=c(-1,1),main="24 variables in a circumplex")


###################################################
### chunk number 11: 
###################################################
#line 300 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
corr.test(sat.act)


###################################################
### chunk number 12: 
###################################################
#line 306 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
r.test(50,.3)


###################################################
### chunk number 13: 
###################################################
#line 311 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
r.test(30,.4,.6)


###################################################
### chunk number 14: 
###################################################
#line 317 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
r.test(103,.4,.5,.1)


###################################################
### chunk number 15: 
###################################################
#line 322 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
r.test(103,.5,.6,.7,.5,.5,.8)  #steiger Case B 


###################################################
### chunk number 16: 
###################################################
#line 329 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
cortest(sat.act)


###################################################
### chunk number 17: 
###################################################
#line 391 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
f3t <- fa(Thurstone,3,n.obs=213)
f3t 


###################################################
### chunk number 18: 
###################################################
#line 411 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(bifactor)
f3 <- fa(Thurstone,3,n.obs = 213,fm="pa")
f3o <- target.rot(f3)
f3o


###################################################
### chunk number 19: 
###################################################
#line 430 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(bifactor)
f3w <- fa(Thurstone,3,n.obs = 213,fm="wls")
print(f3w,cut=0,digits=3)


###################################################
### chunk number 20: 
###################################################
#line 443 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
plot(f3t)


###################################################
### chunk number 21: 
###################################################
#line 454 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
fa.diagram(f3t)


###################################################
### chunk number 22: 
###################################################
#line 472 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(bifactor)
p3p <-principal(Thurstone,3,n.obs = 213,rotate="Promax")
p3p


###################################################
### chunk number 23: 
###################################################
#line 491 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
om.h <- omega(Thurstone,n.obs=213,sl=FALSE)
op <- par(mfrow=c(1,1))


###################################################
### chunk number 24: 
###################################################
#line 502 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
om <- omega(Thurstone,n.obs=213)


###################################################
### chunk number 25: 
###################################################
#line 528 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(bfi)
ic <- iclust(bfi[1:25])


###################################################
### chunk number 26: 
###################################################
#line 540 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
summary(ic)  #show the results


###################################################
### chunk number 27: 
###################################################
#line 564 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
f4 <- fa(bfi[1:25],4,fm="pa")
factor.congruence(f4,ic)


###################################################
### chunk number 28: 
###################################################
#line 570 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
factor.congruence(list(f3t,f3o,om,p3p))


###################################################
### chunk number 29: 
###################################################
#line 610 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
vss <- vss(bfi[1:25],title="Very Simple Structure of a Big 5 inventory")


###################################################
### chunk number 30: 
###################################################
#line 618 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
vss


###################################################
### chunk number 31: 
###################################################
#line 626 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
fa.parallel(bfi[1:25],main="Parallel Analysis of a Big 5 inventory")


###################################################
### chunk number 32: 
###################################################
#line 676 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
set.seed(42)
r9 <- sim.hierarchical(n=500,raw=TRUE)$observed
round(cor(r9),2)
alpha(r9)


###################################################
### chunk number 33: 
###################################################
#line 683 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
keys <- c(1,-1,1,1,1,1,1)
alpha(attitude,keys)


###################################################
### chunk number 34: 
###################################################
#line 689 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
keys <- c(1,1,1,1,1,1,1)
alpha(attitude,keys)


###################################################
### chunk number 35: 
###################################################
#line 697 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
items <- sim.congeneric(N=500,short=FALSE,low=-2,high=2,categorical=TRUE) #500 responses to 4 discrete items
alpha(items$observed)  #item response analysis of congeneric measures


###################################################
### chunk number 36: 
###################################################
#line 752 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
om.9 <- omega(r9,title="9 simulated variables")


###################################################
### chunk number 37: 
###################################################
#line 763 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
om.9


###################################################
### chunk number 38: 
###################################################
#line 769 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
omegaSem(r9,n.obs=500)


###################################################
### chunk number 39: 
###################################################
#line 776 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
guttman(r9)


###################################################
### chunk number 40: 
###################################################
#line 797 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
 keys <- make.keys(nvars=28,list(Agree=c(-1,2:5),Conscientious=c(6:8,-9,-10),
 Extraversion=c(-11,-12,13:15),Neuroticism=c(16:20),
 Openness = c(21,-22,23,24,-25)),
 item.labels=colnames(bfi))
 keys


###################################################
### chunk number 41: 
###################################################
#line 809 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
 keys.1<- make.keys(10,list(Agree=c(-1,2:5),Conscientious=c(6:8,-9,-10)))
keys.2 <- make.keys(15,list(Extraversion=c(-1,-2,3:5),Neuroticism=c(6:10),
 Openness = c(11,-12,13,14,-15)))
 keys.25 <- super.matrix(keys.1,keys.2)


###################################################
### chunk number 42: 
###################################################
#line 821 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
 scores <- score.items(keys,bfi)
 scores


###################################################
### chunk number 43: 
###################################################
#line 829 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
pairs.panels(scores$scores)


###################################################
### chunk number 44: 
###################################################
#line 842 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
r.bfi <- cor(bfi,use="pairwise")
scales <- cluster.cor(keys,r.bfi)
summary(scales)


###################################################
### chunk number 45: 
###################################################
#line 869 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
set.seed(17)
d9 <- sim.irt(9,1000,-2.5,2.5,mod="normal") #dichotomous items
test <- irt.fa(d9$items)
test 


###################################################
### chunk number 46: 
###################################################
#line 878 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
op <- par(mfrow=c(3,1))
plot(test,type="ICC")
plot(test,type="IIC")
plot(test,type="test")
op <- par(mfrow=c(1,1))


###################################################
### chunk number 47: 
###################################################
#line 892 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(bfi)
e.irt <- irt.fa(bfi[11:15])
e.irt 


###################################################
### chunk number 48: 
###################################################
#line 901 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
plot(e.irt,type="IIC")


###################################################
### chunk number 49: 
###################################################
#line 917 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
data(sat.act)

C <- cov(sat.act,use="pairwise")
model1 <- lm(ACT~ gender + education + age, data=sat.act)
summary(model1)


###################################################
### chunk number 50: 
###################################################
#line 925 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
#compare with mat.regress
mat.regress(C,c(1:3),c(4:6), n.obs=700)


###################################################
### chunk number 51: 
###################################################
#line 1006 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
xlim=c(0,10)
ylim=c(0,10)
plot(NA,xlim=xlim,ylim=ylim,main="Demontration of dia functions",axes=FALSE,xlab="",ylab="")
ul <- dia.rect(1,9,labels="upper left",xlim=xlim,ylim=ylim)
ll <- dia.rect(1,3,labels="lower left",xlim=xlim,ylim=ylim)
lr <- dia.ellipse(9,3,"lower right",xlim=xlim,ylim=ylim)
ur <- dia.ellipse(9,9,"upper right",xlim=xlim,ylim=ylim)
ml <- dia.ellipse(3,6,"middle left",xlim=xlim,ylim=ylim)
mr <- dia.ellipse(7,6,"middle right",xlim=xlim,ylim=ylim)
bl <- dia.ellipse(1,1,"bottom left",xlim=xlim,ylim=ylim)
br <- dia.rect(9,1,"bottom right",xlim=xlim,ylim=ylim)
dia.arrow(from=lr,to=ul,labels="right to left")
dia.arrow(from=ul,to=ur,labels="left to right")
dia.curved.arrow(from=lr,to=ll$right,labels ="right to left")
dia.curved.arrow(to=ur,from=ul$right,labels ="left to right")
dia.curve(ll$top,ul$bottom,"double")  #for rectangles, specify where to point 
dia.curved.arrow(mr,ur,"up")  #but for ellipses, just point to it.
dia.curve(ml,mr,"across")
dia.arrow(ur,lr,"top down")
dia.curved.arrow(br$top,lr$bottom,"up")
dia.curved.arrow(bl,br,"left to right")
dia.arrow(bl,ll$bottom)
dia.curved.arrow(ml,ll$right)
dia.curved.arrow(mr,lr$top)


###################################################
### chunk number 52: 
###################################################
#line 1071 "/work/a/ports/math/R-cran-psych/work/psych/inst/doc/overview.Rnw"
sessionInfo()


